from StringIO import StringIO
import string, base64, os

# do xml via basic auth, yeah!
import xmlrpclibBasicAuth

class ZopeSyncer:
    # some private stuff
    def _connect(self): 
        return xmlrpclibBasicAuth.Server(
            self._s, 
            self._u['user'], 
            self._u['pwd'])

    def __init__(self, server=None, user=None):
        self._s = server
        self._u = user

    def _encode(self, s):
        # do any other encoding here
        # eg twofish, zlib etc
        # this will do me for now
        return base64.encodestring(s)

    def _decode(self, s):
        # do any relevant decoding here
        return base64.decodestring(s)

    # the public interface any class needs to expose
    # in order to use ZSyncer
    def objectDelete(self, object):
        """ deletes an object off the server """
        s = self._connect()
        # we dont need to do anything special here, yay!
        try: result = s.manage_add('', object, 0)
        except: return 500
        return result

    def objectSource(self, object=None):
        """ gets the source of the object """
        serverconn = self._serverConn(self._u)
        return serverconn.manage_src(object)

    def objectExport(self, object):
        """ export an object """
        data = StringIO()
        object._p_jar.exportFile(object._p_oid, data)
        data = self._encode(data.getvalue())
        return data

    def objectImport(self, data):
        file = StringIO()
        file.write(self._decode(data))
        file.seek(0)

        new = parent._p_jar.importFile(file)
        parent._setObject(new.getId(), new)

    def objectAdd(self, object=None, add_in=1):
        """ exports an object to the destination """
        # do xml-rpc
        d = self.objectExport(object)
        s = self._connect()
        try: result = serverconn.manage_add(d, object, add_in)
        except: return 500

        # return result
        return result

    def objectList(self, object):
        """ Get information on the source objects """
        server = self._connect()
        return server.manage_listObjects(object)
